package SimpleForm::DisplaySimpleFormAction;

# Copyright (C) 1994 - 2001  eXtropia.com
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA  02111-1307, USA.

use strict;
use Extropia::Base qw(_rearrange _rearrangeAsHash);
use Extropia::Action;

use vars qw(@ISA);
@ISA = qw(Extropia::Action);

sub execute {
    my $self = shift;
    my ($params) = _rearrangeAsHash([
        -APPLICATION_OBJECT,
        -AUTH_MANAGER_CONFIG_PARAMS,
        -FORM_VIEW_NAME,
        -REQUIRE_AUTH_FOR_VIEWING_FORM_FLAG
            ],
            [
        -APPLICATION_OBJECT,
        -FORM_VIEW_NAME,
            ],
        @_
    );

    my $app = $params->{-APPLICATION_OBJECT};

    my $auth_manager;
    if ($params->{-AUTH_MANAGER_CONFIG_PARAMS}) {
        $auth_manager = Extropia::AuthManager->create(@{$params->{-AUTH_MANAGER_CONFIG_PARAMS}})
            or die("Whoopsy!  I was unable to construct the " .
                   "Authentication object. " .
                   "Please contact the webmaster.");
    }

    if ($auth_manager && $params->{-REQUIRE_AUTH_FOR_VIEWING_FORM_FLAG}) {
        $auth_manager->authenticate();
    }


    $app->setNextViewToDisplay(
        -VIEW_NAME => $params->{-FORM_VIEW_NAME}
    );
    return 1;
}
